//
//
// *****************************************************
// *                GDVD - 3.01 beta                   *
// * ------------------------------------------------- *
// *                                                   *
// * Writtin by John Robicheau and Michael R. Eckhoff  *
// * 						       *
// *        With the help of GLADE Gui I.D.E.	       *
// *                                                   *
// * A frontend to 'dvdplay' by Andrew De Quincey and  *
// * Lucien Murray-Pitts.                              *
// *                                                   *
// * Note:  This software is ONLY for the Creative     *
// * Encore 5x DXR2 DVD-PC Kit.  The DXR3 is NOT       *
// * supported by the current driver.  Please do not   *
// * email either myself, Michael, Lucien, or Andrew   *
// * regarding the status of drivers for the Encore 6X *
// * DVD Kit,  thank you.			       			   *
// *						       					   *
// * ------------------------------------------------- *
// * 						       					   *
// *   Please feel free to submit bug reports to:      *
// * 						       					   *
// *         	  havok@havoknet.com                   *
// * 	                  or 			       		   *
// *		       foobar@null.net                 	   *
// *					 	        				   *
// *****************************************************
//
//

#ifdef HAVE_CONFIG_H
#  include <config.h>
#endif

/* ------ INCLUDES  --------- */

#include <gtk/gtk.h>
#include <gnome.h>
#include "callbacks.h"
#include "support.h"



/* ------- DEFINES  ---------- */

#define MAXTIT 5000
#define MAXREC 5000
#define maxlin 4


// ********************************
// *       IDE device defs        *
// ********************************

#define ide1 "/dev/hdb"
#define ide2 "/dev/hdc"
#define ide3 "/dev/hdd"


// ********************************
// *      SCSI device defs        *
// ********************************

#define scsi0 "/dev/scd0"
#define scsi1 "/dev/scd1"
#define scsi2 "/dev/scd2"
#define scsi3 "/dev/scd3"
#define scsi4 "/dev/scd4"
#define scsi5 "/dev/scd5"
#define scsi6 "/dev/scd6"
#define scsi7 "/dev/scd7"
#define scsi8 "/dev/scd8"
#define scsi9 "/dev/scd9"


// ****** MOUNT POINTS ******** //

#define mount1 "/mnt/dvd"
#define mount2 "/dvd"
#define mount3 "/video/dvd"



//gchar*      gtk_editable_get_chars          (GtkEditable *editable,
//                                              gint start_pos,
//                                              gint end_pos);


// *******************************
// * ------ VARIABLES ---------- *
// *******************************


// *******************************
// *     FILE DESCRIPTORS        *
// *******************************

FILE *config;
FILE *fp;
FILE *dvd;
FILE *gatos;
FILE *drive;
FILE *temp;
FILE *dvddb;

// *****************************
// *    CHARACTER VARIABLES    *
// ***************************** 

char inputa[2];
char inputb[20];
char play_command[100];
char mount_dev[10] = ide1;		//This sets the default drive to /dev/hdb
char mount_point[15] = mount1;		//This sets the default mount point to /mnt/dvd
char drive_stat;
char drive_tmp[60];
char vga_geom[20];
char *dvd_title_pre;
char *dvd_title_post;

// ************************************
// *   EXTERNAL CHARACTER VARIABLES   *
// ************************************

extern char ifo_conf[maxlin];
extern char css_conf[maxlin];
extern char angle_conf[maxlin];
extern char sub_on_conf[maxlin];
extern char sub_conf[maxlin];
extern char mnt_dev_conf[maxlin];
extern char mnt_pnt_conf[maxlin];
extern char mnt_type_conf[maxlin];
extern char audio_frq_conf[maxlin];
extern char audio_bit_conf[maxlin];
extern char audio_wth_conf[maxlin];
extern char audio_str_conf[maxlin];
extern char vga_conf[maxlin];
extern char out_type_conf[maxlin];
extern char video_bit_conf[maxlin];
extern char tv_type_conf[maxlin];
extern char out_rat_conf[maxlin];

// ********************************
// *    EXTERNAL INT VARIABLES    *
// ********************************

extern int mount_type;
extern int css;
extern int ifo;
extern int angle;
extern int audio_str;
extern int audio_frq;
extern int audio_bit;
extern int audio_wth;
extern int tv_type;
extern int video_bit;
extern int out_type;
extern int out_rat;
extern int sub;
extern int sub_on;
extern int vga;		// VGA overlay ON/OFF


int mount_type_tmp;
int css_tmp;
int ifo_tmp;
int angle_tmp;
int audio_str_tmp;
int audio_frq_tmp;
int audio_bit_tmp;
int audio_wth_tmp;
int tv_type_tmp;
int video_bit_tmp;
int out_type_tmp;
int out_rat_tmp;
int sub_tmp;
int sub_on_tmp;
int vga_tmp;		// VGA overlay ON/OFF


int popup;
extern int p_status;
		//   The Player Status INT is to determine the current play status of GDVD
		//   Its values are indicative of:
		//
		//		0 - stopped
		//		1 - playing
		// 		2 - paused	
extern int d_status;
		//    The DVD Drive status INT is to determine the status of the Drive, 
		//    mounted, or not.
		//
		//	 	0 - unmounted
		//		1 - mounted
extern int dxr_status; 
		//     The dxr status INT is for wether or not the DXR2 driver module has been loaded.
		//
		//		0 - not loaded
		//		1 - loaded

/*--------------Options variables -------------*/





// *************************************************
// *      INT VARIABLES USED by interface.c        *
// *************************************************

// ---- mount dev ---

int mnt_d;

// ---- mount pnt ---

int mnt_pnt_1;
int mnt_pnt_2;
int mnt_pnt_3;

// ---- mount type ----

int mnt_typ_1;
int mnt_typ_2;

// ---- IFO selection  ----

int ifo_rd_1;
int ifo_rd_2;
int ifo_rd_3;
int ifo_rd_4;
int ifo_rd_5;
int ifo_rd_6;
int ifo_rd_7;
int ifo_rd_8;
int ifo_rd_9;

// ---- Sub ON/OFF -----
int sub_tog;

// ---- Geom ---- //
int geom_stat;



int count = 0;
int filecount;

// ************************************************
// *          GDVD DVD DataBase STRUCT            *
// ************************************************
	
struct dvd{
	char dtitle[MAXTIT];
	int dcss;
	int difo;
	int dsub;
	int dsub_lang;
	int dang;
 	}db[MAXREC];


int size = sizeof (struct dvd);

/* ------------- WIDGETS --------------------*/


GtkWidget *ifo_sel;
//GtkWidget *fileselection1;
GtkWidget *options;
GtkWidget *about;
GtkWidget *already_playing;
GtkWidget *player_paused;
GtkWidget *not_playing;
GtkWidget *already_stopped;
GtkWidget *mt_opt;
GtkWidget *mount;
GtkWidget *geom;
GtkWidget *button;
GtkWidget *dvd_add;
GtkWidget *dvd_select;
GtkWidget *display;
GtkWidget *gdvd;

// **********************************************
// * ----------- MENU ITEMS ------------------- *
// **********************************************


void
on_open1_activate                      (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{

// THIS IS DISABLED FOR THE TIME BEING AND MAY EVEN END UP BEING REMOVED
//
// THERE SEEMS TO BE NO NEED FOR DIRECT FILE SELECTION.

//  fileselection1 = create_fileselection1 ();
//  gtk_widget_show (fileselection1);

}


void
on_exit1_activate                      (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{
gtk_exit(0);
}


void
on_about1_activate                     (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{

  

  about = create_about ();
  gtk_widget_show (about);

}


void
on_options1_activate                   (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{

mount_type_tmp = mount_type;
css_tmp = css;
ifo_tmp = ifo;
angle_tmp = angle;
audio_str_tmp = audio_str;
audio_frq_tmp = audio_frq;
audio_bit_tmp = audio_bit;
audio_wth_tmp = audio_wth;
tv_type_tmp = tv_type;
video_bit_tmp = video_bit;
out_type_tmp = out_type;
out_rat_tmp = out_rat;
sub_tmp = sub;
sub_on_tmp = sub_on;
vga_tmp = vga;				// VGA overlay ON/OFF


   options = create_options ();
   gtk_widget_show (options);


}



void
on_play_vcd1_activate                  (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{



}


void
on_select_ifo_1_activate               (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{



  ifo_sel = create_ifo_sel ();
  gtk_widget_show (ifo_sel);

}


void
on_help1_activate                      (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{

}



void
on_add_dvd1_activate                   (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{

// ********************************************************
// * READ THE DVD DATABASE AND PREPARE IT FOR MORE TITLES *
// ********************************************************

 	dvddb = fopen("/etc/gdvddb.conf", "a+");
	rewind(dvddb);
	while (count < MAXREC && fread(&db[count], size, 1, dvddb) == 1)

		{
			if (count == 0)
			printf("\nCurrent DVD DB contents:\n");
			printf("%s %d %d %d %d %d\n",db[count].dtitle,db[count].dcss,db[count].difo,db[count].dsub,db[count].dsub_lang,db[count].dang);
			count++;
		}
		
		filecount = count;

		fclose(dvddb);

dvd_add = create_dvd_add ();
gtk_widget_show (dvd_add);




}

void
on_select_dvd1_activate                (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{



 	dvddb = fopen("/etc/gdvddb.conf", "a+");
	rewind(dvddb);
	while (count < MAXREC && fread(&db[count], size, 1, dvddb) == 1)

		{
			if (count == 0)
			printf("\nCurrent DVD DB contents:\n");
			printf("%s %d %d %d %d %d\n",db[count].dtitle,db[count].dcss,db[count].difo,db[count].dsub,db[count].dsub_lang,db[count].dang);
			count++;
		}
		
		filecount = count;

		fclose(dvddb);
	



dvd_select = create_dvd_select ();
gtk_widget_show (dvd_select);


}
// ************************************************************************************
// *                            PLAYER CONTROLS                                       *
// ************************************************************************************


void
on_dxr_load_clicked                    (GtkButton       *button,
                                        gpointer         user_data)
{
		if (dxr_status == 0)
			{
			FILE *tmp;
  			printf("\n--------------------------------\n");
  			printf("\nLoading DXR2 Firmware Driver....\n");
  			tmp =  popen("/sbin/modprobe dxr2", "w");
  			pclose(tmp);


  			dxr_status = 1;
  			}
  		else
  			{
			printf("\n-------------------------------\n");
			printf("\nDXR2 Module already loaded.\n");
  			}
}


void
on_unload_clicked                      (GtkButton       *button,
                                        gpointer         user_data)
{
		if (dxr_status == 1)
			{
  			FILE *tmp;
  			printf("\n-------------------------------\n");
  			printf("\nUn Loading DXR2 Firmware Driver\n");
  			tmp = popen("/sbin/modprobe -r dxr2", "w");
  			pclose(tmp);
			dxr_status = 0;
			}
		else
			{
			printf("\n------------------------------\n");
			printf("\nDXR2 Module already un-loaded\n");
			}

}


void
on_mnt_btn_clicked                     (GtkButton       *button,
                                        gpointer         user_data)
{

// *****************************************************
//
// This is an auto detection routine to 'sense' the
// selected dvd's mount status.  Then assign the correct
// value to d_status.
//
// *****************************************************

 FILE *temp;

	snprintf(drive_tmp, sizeof(drive_tmp), "/bin/grep -c %s /etc/mtab > drmnt",mount_point);
	drive = popen(drive_tmp, "w");
	pclose(drive);
	
	fp = fopen("drmnt", "r");
    
	drive_stat = getc(fp);
	printf("%c\n\n",drive_stat);
	fclose(fp);

	temp = popen("/bin/rm -f drmnt", "w");
	pclose(temp);
	
	if (drive_stat == '0')
		{
		d_status = 0;
		//printf("\n The drive is not mounted\n\n\n\n");
		}
	else
		d_status = 1;
		//printf("\n The drive is mounted\n\n\n\n");




		if (d_status == 0 && mount_type == 0)
			{
			FILE *tmp;
  			char buf[1001];
			printf("\n-------------------------------\n");
  			printf("\nMountng DVD Drive (%s) as UDF\n",mount_dev);

  			g_snprintf(buf, sizeof(buf), "/bin/mount -t udf %s %s",mount_dev,mount_point);
  			tmp = popen(buf, "w");
  
  			pclose(tmp);
  			d_status = 1;
  			}
		else if (d_status == 0 && mount_type == 1)
			{
			FILE *tmp;
			char buf[1001];
			printf("\n----------------------------------\n");
			printf("\nMounting DVD Drive (%s) as ISO-9660\n",mount_dev);

			g_snprintf(buf, sizeof(buf), "/bin/mount %s",mount_point);
			tmp = popen(buf, "w");
			d_status = 1;
			}
  		else
  			{
  			printf("\n------------------------------\n");
  			printf("\n Drive is already mounted\n");
  			}


}


void
on_umnt_btn_clicked                    (GtkButton       *button,
                                        gpointer         user_data)
{


// *****************************************************
//
// This is an auto detection routine to 'sense' the
// selected dvd's mount status.  Then assign the correct
// value to d_status.
//
// *****************************************************

 FILE *temp;

	snprintf(drive_tmp, sizeof(drive_tmp), "/bin/grep -c %s /etc/mtab > drmnt",mount_point);
	drive = popen(drive_tmp, "w");
	pclose(drive);
	
	fp = fopen("drmnt", "r");
    
	drive_stat = getc(fp);
	printf("%c\n\n",drive_stat);
	fclose(fp);

	temp = popen("/bin/rm -f drmnt", "w");
	pclose(temp);
	
	if (drive_stat == '0')
		{
		d_status = 0;
		popup = 0;
		}
	else
		d_status = 1;
		popup = 2;


		if (d_status == 1)
			{
			FILE *tmp;
  			char buf[1001];

  			printf("\n-------------------------------\n");
  			printf("\nUn Mounting DVD Player (%s) from %s\n",mount_dev,mount_point);

  			g_snprintf(buf, sizeof(buf), "/bin/umount %s",mount_point);
  
  			tmp =  popen(buf, "w");
  			pclose(tmp);
  			d_status = 0;
  			}
  		else
  			{
  			printf("\n----------------------------------\n");
  			printf("\nDrive is already unmounted\n\n");
  			}
 	popup = 0;
}



void
on_play_clicked                        (GtkButton       *button,
                                        gpointer         user_data)
{
	
  	char buf[1001];

     	if (vga == 0 && sub_on == 0 && css == 0)
     		{
     		g_snprintf(play_command, sizeof(play_command), "/usr/local/bin/dvdplay");
     		}
		else if(vga == 0 && sub_on == 0 && css == 1)
			{
			g_snprintf(play_command, sizeof(play_command), "/usr/local/bin/dvdplay -c");
			}
		else if(vga == 1 && sub_on == 0 && css == 0)
			{
			g_snprintf(play_command, sizeof(play_command), "/usr/local/bin/dvdplay -O -g %s",vga_geom);
			}
		else if(vga == 1 && sub_on == 0 && css == 1)
			{
			g_snprintf(play_command, sizeof(play_command), "/usr/local/bin/dvdplay -cO -g %s",vga_geom);
			}
		else if(vga == 0 && sub_on == 1 && css == 0)
			{
			g_snprintf(play_command, sizeof(play_command), "/usr/local/bin/dvdplay -S%d",sub);
			}
		else if(vga == 0 && sub_on == 1 && css == 1)
			{
			g_snprintf(play_command, sizeof(play_command), "/usr/local/bin/dvdplay -c -S%d",sub);
			}
		else if(vga == 1 && sub_on == 1 && css == 0)
			{
			g_snprintf(play_command, sizeof(play_command), "/usr/local/bin/dvdplay -O -S%d -g %s",sub,vga_geom);
			}
		else if(vga == 1 && sub_on == 1 && css == 1)
			{
			g_snprintf(play_command, sizeof(play_command), "/usr/local/bin/dvdplay -cO -S%d -g %s",sub,vga_geom);
			}
		else
			{
			printf("\n-------------------------------\n");
			printf("\nNo VGA Overlay Settings selected\n");
			}
				


		if (p_status == 0)
			{

	printf("\nAudio Freq:%d\n", audio_frq);
			
			printf("\n\n%s -a%d -T%d -t%d -r%d -s%d -q%d -u%d -w%d -W%d -A %d\n\n",play_command,audio_str,ifo,out_type,out_rat,video_bit,audio_frq,audio_bit,audio_wth,tv_type,angle);
			g_snprintf(buf, sizeof(buf), "%s -a%d -T%d -t%d -r%d -s%d -q%d -u%d -w%d -W%d -A %d",play_command,audio_str,ifo,out_type,out_rat,video_bit,audio_frq,audio_bit,audio_wth,tv_type,angle);
  			dvd = popen(buf, "w");
  			p_status = 1;

  			}
  		else if (p_status == 2)
			{
			printf("\n--------------------------------------\n");
			printf("\nResuming Playback\n");
			fprintf(dvd,"p");
			fflush(dvd);
			p_status = 1;

			}
  		else
  			{
			already_playing = create_already_playing ();
			gtk_widget_show (already_playing);
  			}

 			
}



void
on_stop_clicked                        (GtkButton       *button,
                                        gpointer         user_data)
{

		if (p_status == 1)
			{
			printf("\n-------------------------------\n");
			printf("Stoping\n");

			fprintf(dvd,"s");
			fflush(dvd);
			p_status = 0;

			}
		else if (p_status == 2)
			{
			printf("\n--------------------------------\n");
			printf("\nStopping\n");

			fprintf(dvd,"s");
			fflush(dvd);
			p_status = 0;

			}
		else
			{

			already_stopped = create_already_stopped ();
			gtk_widget_show (already_stopped);
			
			}
}


void
on_pause_clicked                       (GtkButton       *button,
                                        gpointer         user_data)
{


		if (p_status == 1)
			{
			printf("\n--------------------------------------\n");
			printf("\nPausing Player\n");
			
			fprintf(dvd,"p");
			fflush(dvd);
			p_status = 2;

			}
		else if (p_status == 2)
			{
			printf("\n---------------------------------------\n");
			printf("\n\nContinuing Playback\n");

			fprintf(dvd,"p");
			fflush(dvd);
			p_status = 1;

			}
		else
			{

			not_playing = create_not_playing ();
			gtk_widget_show (not_playing);
				
			}

}



void
on_forward_clicked                     (GtkButton       *button,
										gpointer         user_data)
{

		if (p_status == 1)
			{
			printf("\n-------------------------------\n");
  			printf("\nNext Chapter\n");

  			fprintf(dvd,"n");
  			fflush(dvd);
			}
		else if (p_status == 2)
			{

			player_paused = create_player_paused ();
			gtk_widget_show (player_paused);
			
			}
		else
			{


			not_playing = create_not_playing ();
			gtk_widget_show (not_playing);
			
			}

}


void
on_back_clicked                        (GtkButton       *button,
                                        gpointer         user_data)
{
		if (p_status == 1)
			{
			printf("\n-------------------------------\n");
			printf("Going back 1 Chapter");

			fprintf(dvd,"v");
			fflush(dvd);
			}
		else if (p_status == 2)
			{

			player_paused = create_player_paused ();
			gtk_widget_show (player_paused);
			
			}
		else
			{

			not_playing = create_not_playing ();
			gtk_widget_show (not_playing);
			
			}
}



void
on_eject_clicked                       (GtkButton       *button,
                                        gpointer         user_data)
{

FILE *tmp;

tmp = popen("/usr/bin/eject /dev/hdc","w");
pclose(tmp);

}




//-**********************************************************
/* ------------------- File Selection ----------------------*/
//-**********************************************************


// DISABLED

void
on_ok_button_file_clicked              (GtkButton       *button,
                                        gpointer         user_data)
{

//  gtk_widget_destroy(fileselection1);

}



void
on_cancel_button1_clicked              (GtkButton       *button,
                                        gpointer         user_data)
{

//  gtk_widget_destroy(fileselection1);

}







//-*************************************************************************
/* ------------------------- GATOS ON OFF SECTION -------------------------*/
//-*************************************************************************


void
on_gatos_btn_clicked                   (GtkButton       *button,
                                        gpointer         user_data)
{
		FILE *tmp;
		char buf[1001];

		g_snprintf(buf, sizeof(buf), "/usr/local/bin/xatitv");

		printf("\n-------------------------------\n");
		printf("Turning on the tv!\n\n");

		tmp = popen(buf, "w");

		gatos = tmp;
}




/* ------------   IFO SELECTION SECTION   ------------------- */









void
on_ifo_radio_1_toggled                 (GtkToggleButton *togglebutton,
                                        gpointer         user_data)
{
	ifo = 1;
	g_snprintf(ifo_conf, sizeof(ifo_conf), "1");
}


void
on_ifo_radio_2_toggled                 (GtkToggleButton *togglebutton,
                                        gpointer         user_data)
{
	ifo = 2;
	g_snprintf(ifo_conf, sizeof(ifo_conf), "2");
}

void
on_ifo_radio_3_toggled                 (GtkToggleButton *togglebutton,
                                        gpointer         user_data)
{
	ifo = 3;
	g_snprintf(ifo_conf, sizeof(ifo_conf), "3");

}


void
on_ifo_radio_4_toggled                 (GtkToggleButton *togglebutton,
                                        gpointer         user_data)
{
	ifo = 4;
	g_snprintf(ifo_conf, sizeof(ifo_conf), "4");
}


void
on_ifo_radio_5_toggled                 (GtkToggleButton *togglebutton,
                                        gpointer         user_data)
{
	ifo = 5;
	g_snprintf(ifo_conf, sizeof(ifo_conf), "5");
}


void
on_ifo_radio_6_toggled                 (GtkToggleButton *togglebutton,
                                        gpointer         user_data)
{
	ifo = 6;
	g_snprintf(ifo_conf, sizeof(ifo_conf), "6");
}


void
on_ifo_radio_7_toggled                 (GtkToggleButton *togglebutton,
                                        gpointer         user_data)
{
	ifo = 7;
	g_snprintf(ifo_conf, sizeof(ifo_conf), "7");
}


void
on_ifo_radio_8_toggled                 (GtkToggleButton *togglebutton,
                                        gpointer         user_data)
{
	ifo = 8;
	g_snprintf(ifo_conf, sizeof(ifo_conf), "8");

}


void
on_ifo_radio_9_toggled                 (GtkToggleButton *togglebutton,
                                        gpointer         user_data)
{
	ifo = 9;
	g_snprintf(ifo_conf, sizeof(ifo_conf), "9");
}



void
on_ifo_OK_clicked                      (GtkButton       *button,
                                        gpointer         user_data)
{

  gtk_widget_destroy(ifo_sel);

}


void
on_ifo_play_clicked                    (GtkButton       *button,
                                        gpointer         user_data)
{
}


void
on_help_activate                       (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{

}



gboolean
on_play_button_press_event             (GtkWidget       *widget,
                                        GdkEventButton  *event,
                                        gpointer         user_data)
{

  return FALSE;
}


/* ------ Mount Options ----------*/

void
on_opt_mnt_radio_1_toggled             (GtkToggleButton *togglebutton,
                                        gpointer         user_data)
{

	g_snprintf(mount_dev, sizeof(mount_dev), "%s",ide1);
	mnt_d = 1;
	g_snprintf(mnt_dev_conf, sizeof(mnt_dev_conf), "1");
	
}


void
on_opt_mnt_radio_2_toggled             (GtkToggleButton *togglebutton,
                                        gpointer         user_data)
{

	g_snprintf(mount_dev, sizeof(mount_dev), "%s",ide2);
	mnt_d = 2;
	g_snprintf(mnt_dev_conf, sizeof(mnt_dev_conf), "2");
}


void
on_opt_mnt_radio_3_toggled             (GtkToggleButton *togglebutton,
                                        gpointer         user_data)
{

	g_snprintf(mount_dev, sizeof(mount_dev), "%s",ide3);
	mnt_d = 3;
	g_snprintf(mnt_dev_conf, sizeof(mnt_dev_conf), "3");
}



void
on_opt_mnt_scd_0_toggled               (GtkToggleButton *togglebutton,
                                        gpointer         user_data)
{

	g_snprintf(mount_dev, sizeof(mount_dev), "%s",scsi0);
	mnt_d = 4;
	g_snprintf(mnt_dev_conf, sizeof(mnt_dev_conf), "4");

}


void
on_opt_mnt_scd_1_toggled               (GtkToggleButton *togglebutton,
                                        gpointer         user_data)
{

	g_snprintf(mount_dev, sizeof(mount_dev), "%s",scsi1);
	mnt_d = 5;
	g_snprintf(mnt_dev_conf, sizeof(mnt_dev_conf), "5");

}



void
on_opt_mnt_scd_2_toggled               (GtkToggleButton *togglebutton,
                                        gpointer         user_data)
{

	g_snprintf(mount_dev, sizeof(mount_dev), "%s",scsi2);
	mnt_d = 6;
	g_snprintf(mnt_dev_conf, sizeof(mnt_dev_conf), "6");

}



//void
//on_radiobutton3_toggled                (GtkToggleButton *togglebutton,
//                                        gpointer         user_data)
//{
//
//}


void
on_opt_mnt_scd_3_toggled               (GtkToggleButton *togglebutton,
                                        gpointer         user_data)
{

	g_snprintf(mount_dev, sizeof(mount_dev), "%s",scsi3);
	mnt_d = 7;
	g_snprintf(mnt_dev_conf, sizeof(mnt_dev_conf), "7");

}


void
on_opt_mnt_scd_4_toggled               (GtkToggleButton *togglebutton,
                                        gpointer         user_data)
{

	g_snprintf(mount_dev, sizeof(mount_dev), "%s",scsi4);
	mnt_d = 8;
	g_snprintf(mnt_dev_conf, sizeof(mnt_dev_conf), "8");

}


void
on_opt_mnt_scd_5_toggled               (GtkToggleButton *togglebutton,
                                        gpointer         user_data)
{

	g_snprintf(mount_dev, sizeof(mount_dev), "%s",scsi5);
	mnt_d = 9;
	g_snprintf(mnt_dev_conf, sizeof(mnt_dev_conf), "9");

}


void
on_opt_mnt_scd_6_toggled               (GtkToggleButton *togglebutton,
                                        gpointer         user_data)
{

	g_snprintf(mount_dev, sizeof(mount_dev), "%s",scsi6);
	mnt_d = 10;
	g_snprintf(mnt_dev_conf, sizeof(mnt_dev_conf), "10");

}


void
on_opt_mnt_scd_7_toggled               (GtkToggleButton *togglebutton,
                                        gpointer         user_data)
{

	g_snprintf(mount_dev, sizeof(mount_dev), "%s",scsi7);
	mnt_d = 11;
	g_snprintf(mnt_dev_conf, sizeof(mnt_dev_conf), "11");

}


void
on_opt_mnt_scd_8_toggled               (GtkToggleButton *togglebutton,
                                        gpointer         user_data)
{

	g_snprintf(mount_dev, sizeof(mount_dev), "%s",scsi8);
	mnt_d = 12;
	g_snprintf(mnt_dev_conf, sizeof(mnt_dev_conf), "12");

}


void
on_opt_mnt_scd_9_toggled               (GtkToggleButton *togglebutton,
                                        gpointer         user_data)
{

	g_snprintf(mount_dev, sizeof(mount_dev), "%s",scsi9);
	mnt_d = 13;
	g_snprintf(mnt_dev_conf, sizeof(mnt_dev_conf), "13");

}








void
on_opt_mnt_point_1_toggled             (GtkToggleButton *togglebutton,
                                        gpointer         user_data)
{

	g_snprintf(mount_point, sizeof(mount_point), "%s",mount1);

	mnt_pnt_1 = 1;
	mnt_pnt_2 = 0;
	mnt_pnt_3 = 0;

	g_snprintf(mnt_pnt_conf, sizeof(mnt_pnt_conf), "1");

}


void
on_opt_mnt_point_2_toggled             (GtkToggleButton *togglebutton,
                                        gpointer         user_data)
{

	g_snprintf(mount_point, sizeof(mount_point), "%s",mount2);

	mnt_pnt_1 = 0;
	mnt_pnt_2 = 1;
	mnt_pnt_3 = 0;
	
	g_snprintf(mnt_pnt_conf, sizeof(mnt_pnt_conf), "2");

}


void
on_opt_mnt_point_3_toggled             (GtkToggleButton *togglebutton,
                                        gpointer         user_data)
{

	g_snprintf(mount_point, sizeof(mount_point), "%s",mount3);

	mnt_pnt_1 = 0;
	mnt_pnt_2 = 0;
	mnt_pnt_3 = 1;

	g_snprintf(mnt_pnt_conf, sizeof(mnt_pnt_conf), "3");

}


void
on_mnt_type_udf_toggled                (GtkToggleButton *togglebutton,
                                        gpointer         user_data)
{

	mount_type = 0;
	mnt_typ_1 = 1;
	mnt_typ_2 = 0;

	g_snprintf(mnt_type_conf, sizeof(mnt_type_conf), "0");
	
}


void
on_mnt_type_iso_toggled                (GtkToggleButton *togglebutton,
                                        gpointer         user_data)
{

	mount_type = 1;
	mnt_typ_1 = 0;
	mnt_typ_2 = 1;

	g_snprintf(mnt_type_conf, sizeof(mnt_type_conf), "1");
	
}



// *************************************************************
// *                   Option Menu Items                       *
// *************************************************************



// <---------          AUDIO STREAM OPTIONS          ----------->

void
on_opt_audio_str_0_toggled             (GtkToggleButton *togglebutton,
                                        gpointer         user_data)
{

	audio_str_tmp = 0;
	g_snprintf(audio_str_conf, sizeof(audio_str_conf), "0");
}


void
on_opt_audio_str_1_toggled             (GtkToggleButton *togglebutton,
                                        gpointer         user_data)
{

	audio_str_tmp = 1;
	g_snprintf(audio_str_conf, sizeof(audio_str_conf), "1");
}


void
on_opt_audio_str_2_toggled             (GtkToggleButton *togglebutton,
                                        gpointer         user_data)
{

	audio_str_tmp = 2;
	g_snprintf(audio_str_conf, sizeof(audio_str_conf), "2");
}


void
on_opt_audio_str_3_toggled             (GtkToggleButton *togglebutton,
                                        gpointer         user_data)
{

	audio_str_tmp = 3;
	g_snprintf(audio_str_conf, sizeof(audio_str_conf), "3");
}


void
on_opt_audio_str_4_toggled             (GtkToggleButton *togglebutton,
                                        gpointer         user_data)
{

	audio_str_tmp = 4;
	g_snprintf(audio_str_conf, sizeof(audio_str_conf), "4");
}


void
on_opt_audio_str_5_toggled             (GtkToggleButton *togglebutton,
                                        gpointer         user_data)
{

	audio_str_tmp = 5;
	g_snprintf(audio_str_conf, sizeof(audio_str_conf), "5");
}


void
on_opt_audio_str_6_toggled             (GtkToggleButton *togglebutton,
                                        gpointer         user_data)
{

	audio_str_tmp = 6;
	g_snprintf(audio_str_conf, sizeof(audio_str_conf), "6");
}


void
on_opt_audio_str_7_toggled             (GtkToggleButton *togglebutton,
                                        gpointer         user_data)
{

	audio_str_tmp = 7;
	g_snprintf(audio_str_conf, sizeof(audio_str_conf), "7");
}



// < --------         AUDIO FREQUENCY OPTIONS        ----------->

void
on_opt_audio_frq_0_toggled             (GtkToggleButton *togglebutton,
                                        gpointer         user_data)
{
	audio_frq_tmp = 0;
	g_snprintf(audio_frq_conf, sizeof(audio_frq_conf), "0");
}


void
on_opt_audio_frq_1_toggled             (GtkToggleButton *togglebutton,
                                        gpointer         user_data)
{
	audio_frq_tmp = 1;
	g_snprintf(audio_frq_conf, sizeof(audio_frq_conf), "1");
}


void
on_opt_audio_frq_2_toggled             (GtkToggleButton *togglebutton,
                                        gpointer         user_data)
{
	audio_frq_tmp = 2;
	g_snprintf(audio_frq_conf, sizeof(audio_frq_conf), "2");
}


void
on_opt_audio_frq_3_toggled             (GtkToggleButton *togglebutton,
                                        gpointer         user_data)
{
	audio_frq_tmp = 3;
	g_snprintf(audio_frq_conf, sizeof(audio_frq_conf), "3");
}


void
on_opt_audio_frq_4_toggled             (GtkToggleButton *togglebutton,
                                        gpointer         user_data)
{
	audio_frq_tmp = 4;
	g_snprintf(audio_frq_conf, sizeof(audio_frq_conf), "4");
}


// <------------       AUDIO BITRATE OPTIONS   -------------->

void
on_opt_audio_bit_0_toggled             (GtkToggleButton *togglebutton,
                                        gpointer         user_data)
{

	audio_bit_tmp = 0;
	g_snprintf(audio_bit_conf, sizeof(audio_bit_conf), "0");

}


void
on_opt_audio_bit_1_toggled             (GtkToggleButton *togglebutton,
                                        gpointer         user_data)
{

	audio_bit_tmp = 1;
	g_snprintf(audio_bit_conf, sizeof(audio_bit_conf), "1");
}


void
on_opt_audio_bit_2_toggled             (GtkToggleButton *togglebutton,
                                        gpointer         user_data)
{

	audio_bit_tmp = 2;
	g_snprintf(audio_bit_conf, sizeof(audio_bit_conf), "2");
}



//  <-----------        AUDIO WIDTH  OPTION     ------------> 

void
on_opt_audio_wth_0_toggled             (GtkToggleButton *togglebutton,
                                        gpointer         user_data)
{

	audio_wth_tmp = 0;
	g_snprintf(audio_wth_conf, sizeof(audio_wth_conf), "0");
}


void
on_opt_audio_wth_1_toggled             (GtkToggleButton *togglebutton,
                                        gpointer         user_data)
{

	audio_wth_tmp = 1;
	g_snprintf(audio_wth_conf, sizeof(audio_wth_conf), "1");
}


void
on_opt_audio_wth_2_toggled             (GtkToggleButton *togglebutton,
                                        gpointer         user_data)
{

	audio_wth_tmp = 2;
	g_snprintf(audio_wth_conf, sizeof(audio_wth_conf), "2");
}



//******************************************************
//*             VIDEO  OPTIONS  SECTION                *
//******************************************************

  

// <-----------    ANGLE SECTION OPTIONS   ---------------->

void
on_opt_video_ang_0_toggled             (GtkToggleButton *togglebutton,
                                        gpointer         user_data)
{

	angle_tmp = 0;
	g_snprintf(angle_conf, sizeof(angle_conf), "0");

}


void
on_opt_video_ang_1_toggled             (GtkToggleButton *togglebutton,
                                        gpointer         user_data)
{

	angle_tmp = 1;
	g_snprintf(angle_conf, sizeof(angle_conf), "1");

}


void
on_opt_video_ang_2_toggled             (GtkToggleButton *togglebutton,
                                        gpointer         user_data)
{

	angle_tmp = 2;
	g_snprintf(angle_conf, sizeof(angle_conf), "2");

}


void
on_opt_video_ang_3_toggled             (GtkToggleButton *togglebutton,
                                        gpointer         user_data)
{

	angle_tmp = 3;
	g_snprintf(angle_conf, sizeof(angle_conf), "3");

}


void
on_opt_video_ang_4_toggled             (GtkToggleButton *togglebutton,
                                        gpointer         user_data)
{

	angle_tmp = 4;
	g_snprintf(angle_conf, sizeof(angle_conf), "4");

}


void
on_opt_video_ang_5_toggled             (GtkToggleButton *togglebutton,
                                        gpointer         user_data)
{

	angle_tmp = 5;
	g_snprintf(angle_conf, sizeof(angle_conf), "5");

}



//<----------      VGA   OVERLAY  ON / OFF  ------------>

void
on_opt_video_ov_on_toggled             (GtkToggleButton *togglebutton,
                                        gpointer         user_data)
{
	vga_tmp = 1;
	g_snprintf(vga_conf, sizeof(vga_conf), "1");
}


void
on_opt_video_ov_off_toggled            (GtkToggleButton *togglebutton,
                                        gpointer         user_data)
{
	vga_tmp = 0;
	g_snprintf(vga_conf, sizeof(vga_conf), "0");
}




//<-------------  VIDEO  BITSTREM OPTIONS  ------------------>

void
on_opt_video_bit_0_toggled             (GtkToggleButton *togglebutton,
                                        gpointer         user_data)
{
	video_bit_tmp = 0;
	g_snprintf(video_bit_conf, sizeof(video_bit_conf), "0");
}


void
on_opt_video_bit_1_toggled             (GtkToggleButton *togglebutton,
                                        gpointer         user_data)
{
	video_bit_tmp = 1;
	g_snprintf(video_bit_conf, sizeof(video_bit_conf), "1");
}


void
on_opt_video_bit_2_toggled             (GtkToggleButton *togglebutton,
                                        gpointer         user_data)
{
	video_bit_tmp = 2;
	g_snprintf(video_bit_conf, sizeof(video_bit_conf), "2");
}


void
on_opt_video_bit_3_toggled             (GtkToggleButton *togglebutton,
                                        gpointer         user_data)
{
	video_bit_tmp = 3;
	g_snprintf(video_bit_conf, sizeof(video_bit_conf), "3");
}


void
on_opt_video_bit_4_toggled             (GtkToggleButton *togglebutton,
                                        gpointer         user_data)
{
	video_bit_tmp = 4;
	g_snprintf(video_bit_conf, sizeof(video_bit_conf), "4");
}



//<-----------   TV  TYPE  OPTIONS ----------------->

void
on_opt_video2_tv_0_toggled             (GtkToggleButton *togglebutton,
                                        gpointer         user_data)
{
	tv_type_tmp = 0;
	g_snprintf(tv_type_conf, sizeof(tv_type_conf), "0");
}


void
on_opt_video2_tv_1_toggled             (GtkToggleButton *togglebutton,
                                        gpointer         user_data)
{
	tv_type_tmp = 1;
	g_snprintf(tv_type_conf, sizeof(tv_type_conf), "1");
}




//<---------  SUBTITLE  SELECTION  OPTIONS  ------------>

void
on_opt_video2_sub_0_toggled            (GtkToggleButton *togglebutton,
                                        gpointer         user_data)
{

	sub_tmp = 0;
	g_snprintf(sub_conf, sizeof(sub_conf), "0");

}


void
on_opt_video2_sub_1_toggled            (GtkToggleButton *togglebutton,
                                        gpointer         user_data)
{

	sub_tmp = 1;
	g_snprintf(sub_conf, sizeof(sub_conf), "1");

}


void
on_opt_video2_sub_2_toggled            (GtkToggleButton *togglebutton,
                                        gpointer         user_data)
{

	sub_tmp = 2;
	g_snprintf(sub_conf, sizeof(sub_conf), "2");

}


void
on_opt_video2_sub_3_toggled            (GtkToggleButton *togglebutton,
                                        gpointer         user_data)
{

	sub_tmp = 3;
	g_snprintf(sub_conf, sizeof(sub_conf), "3");

}


void
on_opt_video2_sub_4_toggled            (GtkToggleButton *togglebutton,
                                        gpointer         user_data)
{


	sub_tmp = 4;
	g_snprintf(sub_conf, sizeof(sub_conf), "4");

}


void
on_opt_video2_sub_5_toggled            (GtkToggleButton *togglebutton,
                                        gpointer         user_data)
{

	sub_tmp = 5;
	g_snprintf(sub_conf, sizeof(sub_conf), "5");

}


void
on_opt_video2_sub_6_toggled            (GtkToggleButton *togglebutton,
                                        gpointer         user_data)
{

	sub_tmp = 6;
	g_snprintf(sub_conf, sizeof(sub_conf), "6");

}


void
on_opt_video2_sub_7_toggled            (GtkToggleButton *togglebutton,
                                        gpointer         user_data)
{

	sub_tmp = 7;
	g_snprintf(sub_conf, sizeof(sub_conf), "7");

}


void
on_opt_video2_sub_8_toggled            (GtkToggleButton *togglebutton,
                                        gpointer         user_data)
{

	sub_tmp = 8;
	g_snprintf(sub_conf, sizeof(sub_conf), "8");

}



//<---------          OUTPUT TYPE       -------------->


void
on_opt_video2_outt_0_toggled           (GtkToggleButton *togglebutton,
                                        gpointer         user_data)
{
	out_type_tmp = 0;
	g_snprintf(out_type_conf, sizeof(out_type_conf), "0");
}


void
on_opt_video2_outt_1_toggled           (GtkToggleButton *togglebutton,
                                        gpointer         user_data)
{
	out_type_tmp = 1;
	g_snprintf(out_type_conf, sizeof(out_type_conf), "0");
}


void
on_opt_video2_outt_2_toggled           (GtkToggleButton *togglebutton,
                                        gpointer         user_data)
{
	out_type_tmp = 2;
	g_snprintf(out_type_conf, sizeof(out_type_conf), "2");
}


void
on_opt_video2_outt_3_toggled           (GtkToggleButton *togglebutton,
                                        gpointer         user_data)
{
	out_type_tmp = 3;
	g_snprintf(out_type_conf, sizeof(out_type_conf), "3");
}


void
on_opt_video2_outt_4_toggled           (GtkToggleButton *togglebutton,
                                        gpointer         user_data)
{
	out_type_tmp = 4;
	g_snprintf(out_type_conf, sizeof(out_type_conf), "4");
}


void
on_opt_video2_outt_5_toggled           (GtkToggleButton *togglebutton,
                                        gpointer         user_data)
{
	out_type_tmp = 5;
	g_snprintf(out_type_conf, sizeof(out_type_conf), "5");
}


void
on_opt_video2_outt_6_toggled           (GtkToggleButton *togglebutton,
                                        gpointer         user_data)
{
	out_type_tmp = 6;
	g_snprintf(out_type_conf, sizeof(out_type_conf), "6");
}


void
on_opt_video2_outt_7_toggled           (GtkToggleButton *togglebutton,
                                        gpointer         user_data)
{
	out_type_tmp = 7;
	g_snprintf(out_type_conf, sizeof(out_type_conf), "7");
}



//<---------    OUTPUT  RATIO  OPTIONS    ------------->

void
on_opt_video2_outr_0_toggled           (GtkToggleButton *togglebutton,
                                        gpointer         user_data)
{
	out_rat_tmp = 0;
	g_snprintf(out_rat_conf, sizeof(out_rat_conf), "0");
}


void
on_opt_video2_outr_1_toggled           (GtkToggleButton *togglebutton,
                                        gpointer         user_data)
{
	out_rat_tmp = 1;
	g_snprintf(out_rat_conf, sizeof(out_rat_conf), "1");
}


void
on_opt_video2_outr_2_toggled           (GtkToggleButton *togglebutton,
                                        gpointer         user_data)
{
	out_rat_tmp = 2;
	g_snprintf(out_rat_conf, sizeof(out_rat_conf), "2");
}

//---------------------------------------------------------------
//
//  ************************************************************
//  *               OPTION  DIALOG  BUTTONS                    *
//  ************************************************************
//
//----------------------------------------------------------------


void
on_opt_ok_clicked                      (GtkButton       *button,
                                        gpointer         user_data)
{

	FILE *temp;
	temp = fopen("/etc/gdvd.conf", "wb");
	fprintf(temp, "%s\n%s\n%s\n%s\n%s\n%s\n%s\n%s\n%s\n%s\n%s\n%s\n%s\n%s\n%s\n%s\n%s"
					,css_conf,ifo_conf,sub_on_conf,sub_conf,angle_conf,mnt_dev_conf,mnt_pnt_conf,
					mnt_type_conf,audio_frq_conf,audio_bit_conf,audio_wth_conf,audio_str_conf,
					vga_conf,out_type_conf,video_bit_conf,tv_type_conf,out_rat_conf);
	fclose(temp);
	gtk_widget_destroy(options);
	
	audio_frq = audio_frq_tmp;
	sub_on = sub_on_tmp;
	sub = sub_tmp;
	angle = angle_tmp;
	audio_bit = audio_bit_tmp;
	audio_wth = audio_wth_tmp;
	audio_str = audio_str_tmp;
	vga = vga_tmp;
	out_type = out_type_tmp;
	video_bit = video_bit_tmp;
	tv_type = tv_type_tmp;
	out_rat = out_rat_tmp;

printf("\nAudio Freq: %d\n", audio_frq);

}


void
on_opt_apply_clicked                   (GtkButton       *button,
                                        gpointer         user_data)
{



	FILE *temp;
	temp = fopen("/etc/gdvd.conf", "wb");
	fprintf(temp, "%s\n%s\n%s\n%s\n%s\n%s\n%s\n%s\n%s\n%s\n%s\n%s\n%s\n%s\n%s\n%s\n%s"
		,css_conf,ifo_conf,sub_on_conf,sub_conf,angle_conf,mnt_dev_conf,mnt_pnt_conf,
			mnt_type_conf,audio_frq_conf,audio_bit_conf,audio_wth_conf,audio_str_conf,
				vga_conf,out_type_conf,video_bit_conf,tv_type_conf,out_rat_conf);
	fclose(temp);

	audio_frq = audio_frq_tmp;
	sub_on = sub_on_tmp;
	sub = sub_tmp;
	angle = angle_tmp;
	audio_bit = audio_bit_tmp;
	audio_wth = audio_wth_tmp;
	audio_str = audio_str_tmp;
	vga = vga_tmp;
	out_type = out_type_tmp;
	video_bit = video_bit_tmp;
	tv_type = tv_type_tmp;
	out_rat = out_rat_tmp;


printf("\nAudio Freq: %d\n", audio_frq);

}



void
on_opt_cancel_clicked                  (GtkButton       *button,
                                        gpointer         user_data)
{

  gtk_widget_destroy(options);

}



//  **************************************************
//  *           ABOUT POPUP OK BUTTON                *
//  **************************************************

void
on_about_ok_clicked             		(GtkButton       *button,
                                        gpointer         user_data)
{

  gtk_widget_destroy(about);

}







void
on_mount_yes_clicked                   (GtkButton       *button,
                                        gpointer         user_data)
{

mt_opt = create_mt_opt ();
gtk_widget_show (mt_opt);


gtk_widget_destroy (mount);

popup = 2;

}






void
on_already_playing_OK_clicked          (GtkButton       *button,
                                        gpointer         user_data)
{

  gtk_widget_destroy(already_playing);

}


void
on_player_paused_OK_clicked            (GtkButton       *button,
                                        gpointer         user_data)
{

  gtk_widget_destroy(player_paused);

}


void
on_not_playing_OK_clicked              (GtkButton       *button,
                                        gpointer         user_data)
{

  gtk_widget_destroy(not_playing);

}


void
on_already_stopped_OK_clicked          (GtkButton       *button,
                                        gpointer         user_data)
{

  gtk_widget_destroy(already_stopped);

}








// ****************************************
// *           SUB ON / OFF               *
// **************************************** 


void
on_sub_on_toggled                      (GtkToggleButton *togglebutton,
                                        gpointer         user_data)
{

	sub_on_tmp = 1;
	sub_tog = 1;
	g_snprintf(sub_on_conf, sizeof(sub_on_conf), "1");

}


void
on_sub_off_toggled                     (GtkToggleButton *togglebutton,
                                        gpointer         user_data)
{

	sub_on_tmp = 0;
	sub_tog = 0;
	g_snprintf(sub_on_conf, sizeof(sub_on_conf), "0");


}



// ---------- what are these?? ----------------------
void
on_radiobutton1_toggled                (GtkToggleButton *togglebutton,
                                        gpointer         user_data)
{

}


void
on_radiobutton2_toggled                (GtkToggleButton *togglebutton,
                                        gpointer         user_data)
{

}
// --------------------------------------------------



void
on_ifo_select_clicked                  (GtkButton       *button,
                                        gpointer         user_data)
{

  ifo_sel = create_ifo_sel ();
  gtk_widget_show (ifo_sel);

}


void
on_opt_button_clicked                  (GtkButton       *button,
                                        gpointer         user_data)
{

mount_type_tmp = mount_type;
css_tmp = css;
ifo_tmp = ifo;
angle_tmp = angle;
audio_str_tmp = audio_str;
audio_frq_tmp = audio_frq;
audio_bit_tmp = audio_bit;
audio_wth_tmp = audio_wth;
tv_type_tmp = tv_type;
video_bit_tmp = video_bit;
out_type_tmp = out_type;
out_rat_tmp = out_rat;
sub_tmp = sub;
sub_on_tmp = sub_on;
vga_tmp = vga;				// VGA overlay ON/OFF



   options = create_options ();
   gtk_widget_show (options);

}











void
on_css_on_toggled                      (GtkToggleButton *togglebutton,
                                        gpointer         user_data)
{

css = 1;
//css_conf = "1";
	g_snprintf(css_conf, sizeof(css_conf), "1");
}


void
on_css_off_toggled                     (GtkToggleButton *togglebutton,
                                        gpointer         user_data)
{

css = 0;
	g_snprintf(css_conf, sizeof(css_conf), "0");
//css_conf = "0";

}







void
on_mount_no_clicked                    (GtkButton       *button,
                                        gpointer         user_data)
{

//gtk_widget_hide (mount);

}



void
on_m_dev_1_toggled                     (GtkToggleButton *togglebutton,
                                        gpointer         user_data)
{
	g_snprintf(mount_dev, sizeof(mount_dev), "%s",ide1);

	mnt_d = 1;


	
}


void
on_m_dev_2_toggled                     (GtkToggleButton *togglebutton,
                                        gpointer         user_data)
{
	g_snprintf(mount_dev, sizeof(mount_dev), "%s",ide2);

	mnt_d = 2;

}


void
on_m_dev_3_toggled                     (GtkToggleButton *togglebutton,
                                        gpointer         user_data)
{
	g_snprintf(mount_dev, sizeof(mount_dev), "%s",ide3);

	mnt_d = 3;

}


void
on_m_scsi_0_toggled                    (GtkToggleButton *togglebutton,
                                        gpointer         user_data)
{

	g_snprintf(mount_dev, sizeof(mount_dev), "%s",scsi0);

	mnt_d = 4;

}


void
on_m_scsi_1_toggled                    (GtkToggleButton *togglebutton,
                                        gpointer         user_data)
{

	g_snprintf(mount_dev, sizeof(mount_dev), "%s",scsi1);

	mnt_d = 5;

}


void
on_m_scsi_2_toggled                    (GtkToggleButton *togglebutton,
                                        gpointer         user_data)
{

	g_snprintf(mount_dev, sizeof(mount_dev), "%s",scsi2);

	mnt_d = 6;

}


void
on_m_scsi_3_toggled                    (GtkToggleButton *togglebutton,
                                        gpointer         user_data)
{

	g_snprintf(mount_dev, sizeof(mount_dev), "%s",scsi3);

	mnt_d = 7;

}


void
on_m_scsi_4_toggled                    (GtkToggleButton *togglebutton,
                                        gpointer         user_data)
{

	g_snprintf(mount_dev, sizeof(mount_dev), "%s",scsi4);

	mnt_d = 8;

}


void
on_m_scsi_5_toggled                    (GtkToggleButton *togglebutton,
                                        gpointer         user_data)
{

	g_snprintf(mount_dev, sizeof(mount_dev), "%s",scsi5);

	mnt_d = 9;

}


void
on_m_scsi_6_toggled                    (GtkToggleButton *togglebutton,
                                        gpointer         user_data)
{

	g_snprintf(mount_dev, sizeof(mount_dev), "%s",scsi6);

	mnt_d = 10;

}


void
on_m_scsi_7_toggled                    (GtkToggleButton *togglebutton,
                                        gpointer         user_data)
{

	g_snprintf(mount_dev, sizeof(mount_dev), "%s",scsi7);

	mnt_d = 11;

}


void
on_m_scsi_8_toggled                    (GtkToggleButton *togglebutton,
                                        gpointer         user_data)
{

	g_snprintf(mount_dev, sizeof(mount_dev), "%s",scsi8);

	mnt_d = 12;

}


void
on_m_scsi_9_toggled                    (GtkToggleButton *togglebutton,
                                        gpointer         user_data)
{

	g_snprintf(mount_dev, sizeof(mount_dev), "%s",scsi9);

	mnt_d = 13;

}





void
on_m_mnt_1_toggled                     (GtkToggleButton *togglebutton,
                                        gpointer         user_data)
{

	g_snprintf(mount_point, sizeof(mount_point), "%s",mount1);
	

	mnt_pnt_1 = 1;
	mnt_pnt_2 = 0;
	mnt_pnt_3 = 0;


}


void
on_m_mnt_2_toggled                     (GtkToggleButton *togglebutton,
                                        gpointer         user_data)
{

	g_snprintf(mount_point, sizeof(mount_point), "%s",mount2);

	mnt_pnt_1 = 0;
	mnt_pnt_2 = 1;
	mnt_pnt_3 = 0;


}


void
on_m_mnt_3_toggled                     (GtkToggleButton *togglebutton,
                                        gpointer         user_data)
{

	g_snprintf(mount_point, sizeof(mount_point), "%s",mount3);

	mnt_pnt_1 = 0;
	mnt_pnt_2 = 0;
	mnt_pnt_3 = 1;


}


void
on_m_type_1_toggled                    (GtkToggleButton *togglebutton,
                                        gpointer         user_data)
{

	mount_type = 0;

	mnt_typ_1 = 1;
	mnt_typ_2 = 0;

}


void
on_m_type_2_toggled                    (GtkToggleButton *togglebutton,
                                        gpointer         user_data)
{

	mount_type = 1;

	mnt_typ_1 = 1;
	mnt_typ_2 = 0;

}


void
on_mt_MOUNT_clicked                    (GtkButton       *button,
                                        gpointer         user_data)
{


	 FILE *temp;

	snprintf(drive_tmp, sizeof(drive_tmp), "/bin/grep -c %s /etc/mtab > drmnt",mount_point);
	drive = popen(drive_tmp, "w");
	pclose(drive);
	
	fp = fopen("drmnt", "r");
    
	drive_stat = getc(fp);
	printf("%c\n\n",drive_stat);
	fclose(fp);

	temp = popen("/bin/rm -f drmnt", "w");
	pclose(temp);
	
	if (drive_stat == '0')
		{
		d_status = 0;
		//printf("\n The drive is not mounted\n\n\n\n");
		}
	else
		d_status = 1;
		popup = 2;
		//printf("\n The drive is mounted\n\n\n\n");




		if (d_status == 0 && mount_type == 0)
			{
			FILE *tmp;
  			char buf[1001];
			printf("\n-------------------------------\n");
  			printf("\nMountng DVD Drive (%s) as UDF\n",mount_dev);

  			g_snprintf(buf, sizeof(buf), "/bin/mount -t udf %s %s",mount_dev,mount_point);
  			tmp = popen(buf, "w");
  
  			pclose(tmp);
  			d_status = 1;
  			}
		else if (d_status == 0 && mount_type == 1)
			{
			FILE *tmp;
			char buf[1001];
			printf("\n----------------------------------\n");
			printf("\nMounting DVD Drive (%s) as ISO-9660\n",mount_dev);

			g_snprintf(buf, sizeof(buf), "/bin/mount %s",mount_point);
			tmp = popen(buf, "w");
			d_status = 1;
			}
  		else
  			{
  			printf("\n------------------------------\n");
  			printf("\n Drive is already mounted\n");
  			}


gtk_widget_destroy (mt_opt);

}


void
on_mt_CANCEL_clicked                   (GtkButton       *button,
                                        gpointer         user_data)
{

gtk_widget_destroy (mt_opt);

}




void
on_mount_yes_destroy                   (GtkObject       *object,
                                        gpointer         user_data)
{

}


void
on_play_enter                          (GtkButton       *button,
                                        gpointer         user_data)
{



if (popup == 0)
   {
	snprintf(drive_tmp, sizeof(drive_tmp), "/bin/grep -c dvd /etc/mtab > /tmp/drmnt");
	drive = popen(drive_tmp, "w");
	pclose(drive);
	
	fp = fopen("/tmp/drmnt", "r");
    
	drive_stat = getc(fp);
	printf("%c\n\n",drive_stat);
	fclose(fp);

	temp = popen("/bin/rm -f drmnt", "w");
	pclose(temp);
	
	if (drive_stat == '0')
		{
		d_status = 0;

		mount = create_mount ();
		gtk_widget_show (mount);
		popup =0;
		
		}
	else
		{
		d_status = 1;
		popup = 2;
		}
		
	}

else if (popup == 1)
	{
	printf("\n\nPop-up is already open\n\n");
	}
else if (popup == 2)
	{
	printf(" ");
	}
	



	
}


void
on_geom_opt_clicked                    (GtkButton       *button,
                                        gpointer         user_data)
{

}


void
on_geom_btn_clicked                    (GtkButton       *button,
                                        gpointer         user_data)
{

geom = create_geom ();
gtk_widget_show (geom);

}


void
on_crop_btn_clicked                    (GtkButton       *button,
                                        gpointer         user_data)
{

}


// *************************************
// *     GEOMETRY SELECTION SECTION    *
// *************************************


void
on_geom_1_toggled                      (GtkToggleButton *togglebutton,
                                        gpointer         user_data)
{

	g_snprintf(vga_geom, sizeof(vga_geom), "350x450+10+10");
	printf("\n\n%s geometry selected\n",vga_geom);

	geom_stat = 1;

}


void
on_geom_2_toggled                      (GtkToggleButton *togglebutton,
                                        gpointer         user_data)
{
	g_snprintf(vga_geom, sizeof(vga_geom), "350x450+20+20");
	printf("\n\n%s geometry selected\n",vga_geom);

	geom_stat = 2;
}


void
on_geom_3_toggled                      (GtkToggleButton *togglebutton,
                                        gpointer         user_data)
{
	g_snprintf(vga_geom, sizeof(vga_geom), "350x450+30+30");
	printf("\n\n%s geometry selected\n",vga_geom);

	geom_stat = 3;
}


void
on_geom_4_toggled                      (GtkToggleButton *togglebutton,
                                        gpointer         user_data)
{
	g_snprintf(vga_geom, sizeof(vga_geom), "350x450+40+40");
	printf("\n\n%s geometry selected\n",vga_geom);

	geom_stat = 4;
}


void
on_geom_5_toggled                      (GtkToggleButton *togglebutton,
                                        gpointer         user_data)
{
	g_snprintf(vga_geom, sizeof(vga_geom), "350x450+50+50");
	printf("\n\n%s geometry selected\n",vga_geom);

	geom_stat = 5;
}


void
on_geom_6_toggled                      (GtkToggleButton *togglebutton,
                                        gpointer         user_data)
{
	g_snprintf(vga_geom, sizeof(vga_geom), "350x450+60+60");
	printf("\n\n%s geometry selected\n",vga_geom);

	geom_stat = 6;
}


void
on_geom_7_toggled                      (GtkToggleButton *togglebutton,
                                        gpointer         user_data)
{
	g_snprintf(vga_geom, sizeof(vga_geom), "350x450+70+70");
	printf("\n\n%s geometry selected\n",vga_geom);

	geom_stat = 7;
}


void
on_geom_8_toggled                      (GtkToggleButton *togglebutton,
                                        gpointer         user_data)
{
	g_snprintf(vga_geom, sizeof(vga_geom), "350x450+80+80");
	printf("\n\n%s geometry selected\n",vga_geom);

	geom_stat = 8;
}


void
on_geom_9_toggled                      (GtkToggleButton *togglebutton,
                                        gpointer         user_data)
{
	g_snprintf(vga_geom, sizeof(vga_geom), "350x450+90+90");
	printf("\n\n%s geometry selected\n",vga_geom);

	geom_stat = 9;
}


void
on_geom_10_toggled                     (GtkToggleButton *togglebutton,
                                        gpointer         user_data)
{
	g_snprintf(vga_geom, sizeof(vga_geom), "350x450+100+100");
	printf("\n\n%s geometry selected\n",vga_geom);

	geom_stat = 10;
}


void
on_geom_11_toggled                     (GtkToggleButton *togglebutton,
                                        gpointer         user_data)
{
	g_snprintf(vga_geom, sizeof(vga_geom), "640x480+10+10");
	printf("\n\n%s geometry selected\n",vga_geom);

	geom_stat = 11;
}


void
on_geom_12_toggled                     (GtkToggleButton *togglebutton,
                                        gpointer         user_data)
{
	g_snprintf(vga_geom, sizeof(vga_geom), "640x480+20+20");
	printf("\n\n%s geometry selected\n",vga_geom);

	geom_stat = 12;
}


void
on_geom_13_toggled                     (GtkToggleButton *togglebutton,
                                        gpointer         user_data)
{
	g_snprintf(vga_geom, sizeof(vga_geom), "640x480+30+30");
	printf("\n\n%s geometry selected\n",vga_geom);

	geom_stat = 13;
}


void
on_geom_14_toggled                     (GtkToggleButton *togglebutton,
                                        gpointer         user_data)
{
	g_snprintf(vga_geom, sizeof(vga_geom), "640x480+40+40");
	printf("\n\n%s geometry selected\n",vga_geom);

	geom_stat = 14;
}


void
on_geom_15_toggled                     (GtkToggleButton *togglebutton,
                                        gpointer         user_data)
{
	g_snprintf(vga_geom, sizeof(vga_geom), "640x480+50+50");
	printf("\n\n%s geometry selected\n",vga_geom);

	geom_stat = 15;
}


void
on_geom_16_toggled                     (GtkToggleButton *togglebutton,
                                        gpointer         user_data)
{
	g_snprintf(vga_geom, sizeof(vga_geom), "640x480+60+60");
	printf("\n\n%s geometry selected\n",vga_geom);

	geom_stat = 16;
}


void
on_geom_17_toggled                     (GtkToggleButton *togglebutton,
                                        gpointer         user_data)
{
	g_snprintf(vga_geom, sizeof(vga_geom), "640x480+70+70");
	printf("\n\n%s geometry selected\n",vga_geom);

	geom_stat = 17;
}


void
on_geom_80_toggled                     (GtkToggleButton *togglebutton,
                                        gpointer         user_data)
{
	g_snprintf(vga_geom, sizeof(vga_geom), "640x480+80+80");
	printf("\n\n%s geometry selected\n",vga_geom);

	geom_stat = 18;
}


void
on_geom_19_toggled                     (GtkToggleButton *togglebutton,
                                        gpointer         user_data)
{
	g_snprintf(vga_geom, sizeof(vga_geom), "640x480+90+90");
	printf("\n\n%s geometry selected\n",vga_geom);

	geom_stat = 19;
}


void
on_geom_20_toggled                     (GtkToggleButton *togglebutton,
                                        gpointer         user_data)
{
	g_snprintf(vga_geom, sizeof(vga_geom), "640x480+100+100");
	printf("\n\n%s geometry selected\n",vga_geom);

	geom_stat = 20;
}


void
on_geom_OK_clicked                     (GtkButton       *button,
                                        gpointer         user_data)
{

gtk_widget_destroy (geom);

}







void
on_dvd_add_ifo_1_toggled               (GtkToggleButton *togglebutton,
                                        gpointer         user_data)
{
db[count].difo = 1;

}


void
on_dvd_add_ifo_4_toggled               (GtkToggleButton *togglebutton,
                                        gpointer         user_data)
{
db[count].difo = 4;

}


void
on_dvd_add_ifo_7_toggled               (GtkToggleButton *togglebutton,
                                        gpointer         user_data)
{
db[count].difo = 7;

}


void
on_dvd_add_ifo_2_toggled               (GtkToggleButton *togglebutton,
                                        gpointer         user_data)
{
db[count].difo = 2;


}


void
on_dvd_add_ifo_5_toggled               (GtkToggleButton *togglebutton,
                                        gpointer         user_data)
{
db[count].difo = 5;


}


void
on_dvd_add_ifo_8_toggled               (GtkToggleButton *togglebutton,
                                        gpointer         user_data)
{
db[count].difo = 8;


}


void
on_dvd_add_ifo_3_toggled               (GtkToggleButton *togglebutton,
                                        gpointer         user_data)
{
db[count].difo = 3;


}


void
on_dvd_add_ifo_6_toggled               (GtkToggleButton *togglebutton,
                                        gpointer         user_data)
{
db[count].difo = 6;


}


void
on_dvd_add_ifo_9_toggled               (GtkToggleButton *togglebutton,
                                        gpointer         user_data)
{
db[count].difo = 9;


}


void
on_dvd_add_css_on_toggled              (GtkToggleButton *togglebutton,
                                        gpointer         user_data)
{
db[count].dcss = 1;
}


void
on_dvd_add_css_off_toggled             (GtkToggleButton *togglebutton,
                                        gpointer         user_data)
{
db[count].dcss = 0;
}


void
on_dvd_add_sub_on_toggled              (GtkToggleButton *togglebutton,
                                        gpointer         user_data)
{

db[count].dsub = 1;


}

void
on_dvd_add_sub_off_toggled             (GtkToggleButton *togglebutton,
                                        gpointer         user_data)
{
db[count].dsub = 0;


}


void
on_dvd_add_lang_1_toggled              (GtkToggleButton *togglebutton,
                                        gpointer         user_data)
{
db[count].dsub_lang = 1;


}


void
on_dvd_add_lang_2_toggled              (GtkToggleButton *togglebutton,
                                        gpointer         user_data)
{
db[count].dsub_lang = 2;


}


void
on_dvd_add_lang_3_toggled              (GtkToggleButton *togglebutton,
                                        gpointer         user_data)
{
db[count].dsub_lang = 3;


}


void
on_dvd_add_lang_4_toggled              (GtkToggleButton *togglebutton,
                                        gpointer         user_data)
{
db[count].dsub_lang = 4;


}


void
on_dvd_add_lang_5_toggled              (GtkToggleButton *togglebutton,
                                        gpointer         user_data)
{
db[count].dsub_lang = 5;


}


void
on_dvd_add_lang_6_toggled              (GtkToggleButton *togglebutton,
                                        gpointer         user_data)
{
db[count].dsub_lang = 6;


}


void
on_dvd_add_lang_7_toggled              (GtkToggleButton *togglebutton,
                                        gpointer         user_data)
{
db[count].dsub_lang = 7;


}


void
on_dvd_add_lang_8_toggled              (GtkToggleButton *togglebutton,
                                        gpointer         user_data)
{
db[count].dsub_lang = 8;


}


void
on_dvd_add_lang_9_toggled              (GtkToggleButton *togglebutton,
                                        gpointer         user_data)
{
db[count].dsub_lang = 9;


}


void
on_dvd_add_ang_1_toggled               (GtkToggleButton *togglebutton,
                                        gpointer         user_data)
{
db[count].dang = 1;

}


void
on_dvd_add_ang_2_toggled               (GtkToggleButton *togglebutton,
                                        gpointer         user_data)
{
db[count].dang = 2;


}


void
on_dvd_add_ang_3_toggled               (GtkToggleButton *togglebutton,
                                        gpointer         user_data)
{
db[count].dang = 3;


}


void
on_dvd_add_ang_4_toggled               (GtkToggleButton *togglebutton,
                                        gpointer         user_data)
{
db[count].dang = 4;

}


void
on_dvd_add_ang_5_toggled               (GtkToggleButton *togglebutton,
                                        gpointer         user_data)
{
db[count].dang = 5;


}


void
on_dvd_add_ang_6_toggled               (GtkToggleButton *togglebutton,
                                        gpointer         user_data)
{
db[count].dang = 6;


}






void
on_dvd_add_text_activate               (GtkEditable     *editable,
                                        gpointer         user_data)
{


//char *ptr, *gets(char *);
//scanf("%s",dvd_title);


}




void
on_dvd_add_ADD_clicked                 (GtkButton       *button,
                                        gpointer         user_data)
{


	GtkWidget *dvd_add;
	GtkWidget *add_dvd_title;
	dvd_add = lookup_widget(GTK_WIDGET( button ) ,"dvd_add");
   	add_dvd_title = lookup_widget(GTK_WIDGET( dvd_add) ,"add_dvd_title");
	dvd_title_pre = gtk_editable_get_chars(GTK_EDITABLE(add_dvd_title),0,-1);


		dvddb = fopen("/etc/gdvddb.conf", "a+");
		rewind(dvddb);
		fseek(dvddb, 0L, SEEK_END);

	g_snprintf(db[count].dtitle, sizeof(db[count].dtitle), "%s",dvd_title_pre);

	//db[count].dtitle = snprintf("%s",dvd_title_pre);
	//fprintf(dvddb, "%s %d %d %d %d %d\n",dvd_title_pre,db[count].dcss,db[count].difo,db[count].dsub,db[count].dsub_lang,db[count].dang);

	
		
		fwrite(&db[filecount], size, 1, dvddb);
		fclose(dvddb);


    gtk_widget_destroy (dvd_add);

}


void
on_dvd_add_CANCEL_clicked              (GtkButton       *button,
                                        gpointer         user_data)
{


gtk_widget_destroy (dvd_add);



}


void
on_dvd_select_text_activate            (GtkEditable     *editable,
                                        gpointer         user_data)
{

}


void
on_dvd_select_SELECT_clicked           (GtkButton       *button,
                                        gpointer         user_data)
{

	GtkWidget *dvd_select;
	GtkWidget *dvd_select_text;
	dvd_select = lookup_widget(GTK_WIDGET( button ) ,"dvd_select");
   	dvd_select_text = lookup_widget(GTK_WIDGET( dvd_select) ,"dvd_select_text");
	dvd_title_post = gtk_editable_get_chars(GTK_EDITABLE(dvd_select_text),0,-1);

	
 	dvddb = fopen("/etc/gdvddb.conf", "a+");
	rewind(dvddb);
	while (count < MAXREC && fread(&db[count], size, 1, dvddb) == 1)

		{
			if (count == 0)
				printf("\n");
				if (strcmp(dvd_title_post,db[count].dtitle) == 0)
						{
						printf("\n%s Selected:\n",dvd_title_post);
						printf("\n\n%s %d %d %d %d %d\n",db[count].dtitle,db[count].dcss,db[count].difo,db[count].dsub,db[count].dsub_lang,db[count].dang);
						

						css = db[count].dcss;
						ifo = db[count].difo;
						sub = db[count].dsub_lang;
						sub_on = db[count].dsub;
						angle = db[count].dang;
						}
							
				else
			
				printf("\n");
			count++;
		}


		fclose(dvddb);





gtk_widget_destroy (dvd_select);



}


void
on_dvd_select_CANCEL_clicked           (GtkButton       *button,
                                        gpointer         user_data)
{

gtk_widget_destroy (dvd_select);

}





void
on_add_dvd_title_activate              (GtkEditable     *editable,
                                        gpointer         user_data)
{

}






